import * as types from "../constants/actionTypes";

import axios from "axios";

const getCategory = payload => ({
	type: types.GET_CATEGORY,
	payload
});

const getCategorySuccess = payload => {
	console.log("payload", payload);
	return {
		type: types.GET_CATEGORY_SUCCESS,
		payload
	};
};

const getCategoryFail = payload => ({
	type: types.GET_CATEGORY_FAIL,
	payload
});

export const getCategoryRequest = ({ page = 1, size = 5 }) => async dispatch => {
	dispatch(getCategory());
	const token = localStorage.getItem("token");
	try {
		const { data } = await axios({
			method: "GET",
			url: "https://test-app-a-level.herokuapp.com/category",
			headers: {
				Authorization: `Bearer ${token}`
			},
			params: {
				page,
				size
			}
		});
		dispatch(getCategorySuccess(data));
	} catch (err) {
		dispatch(getCategoryFail(err));
	}
};
