import React, { Component } from "react";
import { connect } from "react-redux";
import { Link } from "react-router-dom";
import { bindActionCreators } from "redux";
import { Pagination } from "antd";

import * as actions from "../actions/category";

import Loader from "../components/HOC/loader";
import WrapperComponent from "../components/HOC/resize";

class App extends Component {
	state = { current: 1 };

	componentDidMount() {
		const { getCategoryRequest } = this.props;

		getCategoryRequest({});
	}

	onChange = page => {
		const { getCategoryRequest } = this.props;

		this.setState({ current: page });
		getCategoryRequest({ page });
	};

	render() {
		const { category, isFetching, totalCount } = this.props;
		const { current } = this.state;
		return (
			<>
				<Loader flag={isFetching}>
					<div>Home</div>

					<div>
						{category.map(el => (
							<div key={el._id}>
								<Link to={`/category/${el._id}`}>
									<h3>{el.name}</h3>
								</Link>
							</div>
						))}
					</div>
				</Loader>
				<Pagination current={current} onChange={this.onChange} defaultPageSize={5} total={totalCount} />
			</>
		);
	}
}

const mapStateToProps = state => {
	return {
		isFetching: state.category.isFetching,
		category: state.category.data,
		totalCount: state.category.totalCount
	};
};
const mapDispatchToProps = dispatch => bindActionCreators({ ...actions }, dispatch);

export default connect(
	mapStateToProps,
	mapDispatchToProps
)(WrapperComponent(App));
