import React, { Component } from "react";
import { connect } from "react-redux";
import { bindActionCreators } from "redux";
import { Redirect } from "react-router-dom";

import * as actions from "../actions/auth";
import SignIn from "../components/signIn";
import SignUp from "../components/signUp";

class Auth extends Component {
	state = { switchForm: false };

	switchForm = () => this.setState(prevState => ({ switchForm: !prevState.switchForm }));

	render() {
		const { switchForm } = this.state;
		const { auth, token } = this.props;

		if (token) {
			return <Redirect to="/" />;
		}

		return (
			<div className="auth-box">
				<div className="auth-box__wrapper">
					{switchForm ? <SignUp /> : <SignIn auth={auth} token={token} />}

					<button onClick={this.switchForm}>Don't have account?</button>
				</div>
			</div>
		);
	}
}

const mapDispatchToProps = dispatch => bindActionCreators({ ...actions }, dispatch);

const mapStateToProps = state => ({
	token: state.auth.token
});

export default connect(
	mapStateToProps,
	mapDispatchToProps
)(Auth);
