import * as types from "../constants/actionTypes";

import initialState from "../store/initialState";

export default (state = initialState.category, { type, payload }) => {
	switch (type) {
		case types.GET_CATEGORY: {
			return { ...state, isFetching: true };
		}
		case types.GET_CATEGORY_SUCCESS: {
			const { count, category } = payload;
			return { ...state, data: category, totalCount: count, isFetching: false };
		}
		case types.GET_CATEGORY_FAIL: {
			return { ...state, isFetching: false };
		}

		default:
			return state;
	}
};
